@if (@CodeSection == @Batch) @then

:: The first line above is...
:: - in Batch: a valid IF command that does nothing.
:: - in JScript: a conditional compilation IF statement that is false,
::               so this Batch section is omitted until next "at-sign end".


@echo off

rem FindRepl.bat: Utility to search and search/replace strings in a file
rem http://www.dostips.com/forum/viewtopic.php?f=3&t=4697
rem Antonio Perez Ayala

rem   - Jun/26/2013: first version.
rem   - Jul/02/2013: use /Q in submatched substrings, use /VR for /V in Replace, eliminate "\r\n" in blocks.
rem   - Jul/07/2013: change /VR by /R, search for "\r\n" with /$ and no /V, /N nor blocks.

rem   - Nov/20/2014: Version 2 - New switches: /J, /L, /G, /ARG#, and || separate regexp's in /Alternations.

Rem Original check for /? argument is unchanged,
Rem but label is intercepted by a preceeding duplicate to display darts HELP instead
if "%~1" equ "/?" goto showUsage

Rem Modified from FindRepl.bat to intercept HELP when no arguments
Rem Original check for empty argument
if "%~1" equ "" (
    SetLOCAL
    Set "GOTaMinuteMan=1"
Rem goto showUsage %= original target label =%
    goto GetSet
)

if Defined GOTaMinuteMan (
Rem This line is original code
    CScript //nologo //E:JScript "%~F0" %*
) Else (
    Echo.
    Echo.This batch script does not accept command line arguments.
    goto showUsage
)
Rem End of modifications to FindRepl.bat to intercept HELP

exit /B %errorlevel%

<dartusage>
MMDls.bat creates Team schedules for South Shore Minute Man darts.

MMDls [/?]

  /?         Displays this brief HELP

It does not require nor accept any arguments other than /?.

Usage instructions:
   Download to any convenient folder from the distribution source.
   Open that folder using Windows Explorer.
   Right-click and Extract to the same folder.
   Righy-click and Open MMDls.bat (Double-left-click also works)

The user will be prompted for the following:

   1- An optional search string:
         Suggestions for later prompts may be offered.
   2- Alphabetic division level.
   3- Numeric sequence within level.
   4- Team numbet within selected division.
</dartusage>

MMDready.bat copied 69 records from itself to "MMDls.bat"

MMDready.bat generated the following table records:

<Week>
02/06/2018
02/13/2018
02/20/2018
02/27/2018
03/06/2018
03/13/2018
03/20/2018
03/27/2018
04/03/2018
04/10/2018
04/17/2018
04/24/2018
05/01/2018
05/08/2018
05/15/2018
</Week>

<SSDivA0>
1 Round of Nine, Golden Dragon 35 Pleasant St Weymouth 781-337-8881 Kevin Cotter 781-603-3455
2 Arrowheads, Goal Post 226 Water St Quincy 617-471-6306 John Brady 617-347-1770
3 Handsome Devils, Polish Club 55 Wales St Abington 781-878-9822 John Finn 781-706-8766
4 Double Penetration, Polish Club 55 Wales St Abington 781-878-9822 Steve Jacques 617-910-6230
5 YAHTZEE!!, Polish Club 55 Wales St Abington 781-878-9822 David Walsh Jr 617-637-5017
6 Tripaholics, Ply Moose 601 State Rd Plymouth 508-224-2276 Steve Kazorek 339-236-4585
</SSDivA0>
<SSDivA1>
1 WTP, Goal Post 226 Water St Quincy 617-471-6306 Ryan Fabrizio 339-788-7634
2 Heavy Dartillery, Polish Club 55 Wales St Abington 781-878-9822 Rocky Smith 781-603-2243
3 Same Auld Same Auld, Auld Sod 274 Wash St Dedham 781-326-3057 Rob Farmer 617-257-3830
4 Rings of Fire, Walpole VFW 109 Robbins Rd Walpole 508-668-1367 Greg Bishop 508-360-1309
5 Lynch's Hitmen, Lynch's Tavern 236 North Ave Abington 781-878-9881 Fred White 617-967-1807
6 Irish Pub, Irish Pub 51 Billings Rd Quincy 617-774-0222 Noel O'Neill 617-818-1127
7 Ma$$hole$, Lynch's Tavern 236 North Ave Abington 781-878-9881 Tommy Cashman 774-222-0654
8 The Fox, Sly Fox 139 Copeland st Quincy 617-328-5777 Gerry McKenna 617-504-0053
</SSDivA1>
<SSDivA2>
1 Franks and Beans, Whitman Legion 33 Legion Pkwy Whitman 781-447-5253 Bryce Johnson 203-599-5346
2 Legion of Darts, Venus 3 252 Main St Hanson 781-293-0000 Nate Kennedy 781-588-0372
3 Seadogs, Eagles 29 Park St Rockland 781-878-2218 Phil Werth 508-971-3158
4 Make Em All Count, Jones River Tavern 6 Pembroke St Kingston 781-585-4420 Joe Cosgrove 781-738-2919
5 NFC, O'Toole's Pub 24 Raynor Ave Whitman 781-447-0344 Ed Lawrence 781-405-7982
6 Buttah'd Biscuits, Yarmouth Moose 769 Rt 28 South Yarmouth 508-394-2341 Gillian Richmond 508-237-3373
7 Smoke Show, Plymouth VFW 22 Seven Hills Rd Plymouth 508-746-8961 Tyrone Jefferson 781-351-9482
8 Bullbags, Lucioso's 6 Spring Lane Plymouth 508-746-0056 Chris Downey 774-216-9997
</SSDivA2>
<SSDivB1>
1 Phat and Misshaped, Gametime 365 Center Ave Rockland 781-871-2123 Bob Caldeira 617-852-6615
2 Get Some!!!, Abington K of C 254 Hancock St Abing 781-878-9863 Matty Emerson 781-961-9052
3 G.O.A.T. 2.0, Golden Dragon 35 Pleasant St Weymouth 781-337-8881 Bobby MacNeil 781-927-8610
4 Brownie Points, Polish Club 55 Wales St Abington 781-878-9822 Chris Galinauskas 617-959-6859
5 GFY, Lynch's Tavern 236 North Ave Abington 781-878-9881 Leo Albee 781-337-0457
6 South Shoremen of Weymouth, Middle Ground 416 Middle St Wey 781-337-9905 Aaron Ryder 617-420-2271
7 The Nobuddys, Next Page 550 Broad St Weymouth 781-340-1300 Brad Walsh 781-367-1951
8 BYE, NO Match 00 No Location 888-000-0000
</SSDivB1>
<SSDivB2>
1 Assassins, Shooters Pub 36 E Main St Avon 508-580-0069 Jim Gannon 774-766-7084
2 4 F's Sake, Sully's 28 Chestnut St Quincy 617-479-9489 Scott Eisnor 774-259-4426
3 Guess What?, Vega Club 895 Warren Ave Brockton 508-583-9306 Josh Voci 508-818-8555
4 The Villains, The Brook 600 S Frankin St Holbrook 781-767-2528 Tim Choate 774-257-0632
5 Engine One, Enterprise Club 224 Clinton St Brockton 508-583-9710 Chuck Haskell 508-326-6512
6 Pour Decisions, Ben's Pour House 39 E Main St Avon 508-584-9200 Jake Auger 781-571-1037
7 No Name, O'Toole's Pub 24 Raynor Ave Whitman 781-447-0344 Matt Sweeney 781-467-9971
8 BYE, NO Match 00 No Location 888-000-0000
</SSDivB2>
<SSDivC4>
1 Moose Connection, Braintree Moose 175 Howard St Braintree 781-843-9302 Steven Cohen 339-440-0733
2 Fire Bulls, Maggy's 609 Wash St Quincy 617-481-5141 Kevin Coleman 781-901-2537
3 MOFO, Gametime 365 Center Ave Rockland 781-871-2123 Mark Lamoureux 781-424-5698
4 Convicts, Maggy's 609 Wash St Quincy 617-481-5141 Donny Watson 857-249-7720
5 The Next Stage, Next Page 550 Broad St Weymouth 781-340-1300 Craig Cooper 857-342-0246
6 3-0 What?, KC's Pub 1284 Wash St Weymouth 781-340-6666 Paul Kilban 781-799-3823
7 Bill Who?, Players 86 VFW Drive Rockland 781-681-9999 Jay Landy 401-585-0375
8 BYE, NO Match 00 No Location 888-000-0000
</SSDivC4>
<SSDivD1>
1 Full of Bull, Jockey Club 115 Rt 44 Raynham 508-828-9128 Chrissy Bolieiro 774-409-5133
2 Ex-Patriots, Napper Tandy's 1065 Main St Walpole 508-668-1191 Steven Medeiros 508-212-2537
3 Mad Arrows, Chickie Flynn's 94 Washington St Foxborough 508-203-9471 Patrick Keady 508-612-8768
4 BYE, NO Match 00 No Location 888-000-0000
5 Dart-A-Holics, VFW 12 Station St Middleboro 508-947-8646 Allan Howell 508-317-6721
6 WADGAF, Lakeville Country Club 44 Clear Pond Rd Lakeville 508-947-6630 Paul Silvia 508-454-3327
7 Tru Beginnings, Slap Shotz 524 Broadway Raynham 774-501-3346 PJ Hibbard 774-406-8865
8 Silver City Snipers, Atlantic Caf 10 Plain St Taunton 508-824-5144 Jared deSousa 774-281-0041
</SSDivD1>
<SSDivD2>
1 Give Her A Dart, Cottage Bar 26 Union St Weymouth 781-812-2083 Ian Murphy 617-390-4111
2 Chairmen of the Board, The Brook 600 S Franklin St Holbrook 781-767-2528 Eric Bourgea 781-864-7474
3 The Dart Foundation, Coops 520 Wash St Quincy 617-472-2667 Jeff Farnham 508-245-4385
4 Jinkies Darts, Maggy's 609 Wash St Quincy 617-481-5141 George Higgins 617-312-9835
5 Decepticorks, Turnpike Caf 958 Turnpike St Canton 781-828-8231 Suzanne Vogel 781-556-4097
6 SQ Post, Nickerson Post 20 Moon Island Rd Quincy 617-328-9824 Jay Gribaudo 617-406-8622
7 Snake Eyes, Paddy Barry's 1574 Hancock St Quincy 617-770-3620 Steve Yadisernia 617-791-6666
8 BYE, NO Match 00 No Location 888-000-0000
</SSDivD2>
<SSDivD3>
1 The Aeros, Tinker's Son 707 Main St Norwell 781-561-7361 Phil Kelly 781-987-4204
2 Shamrocks+1, Marshfield DAV 108 Dyke Rd Marshfield 781-837-8059 Matt Flaherty 781-679-4481
3 G-Nation, McGreal's Tavern 690 Main St Norwell 781-659-9303 Glenn Jenkins 617-930-9132
4 BYE, NO Match 00 No Location 888-000-0000
5 The Killer V's, Plymouth VFW 22 Seven Hills Rd Plymouth 508-746-8961 Jenn Daly 978-210-4309
6 Bulls Hitters, Venus II 277 Ocean St Marshfield 781-837-6368 Gereth Long 781-733-6086
7 Flite Risk, Rafferty's 10 Snow Rd Marshfield 781-837-3389 Billy Nicholson Jr 781-715-5325
8 One In The Stink, Main St Sports Bar 39 Main St Plymouth 774-783-4129 Eric Yee 508-333-2896
</SSDivD3>
<SSDivD4>
1 420 Shooters, Protectors Club 50 Herrod Ave Brockton 508-588-9647 Carlos Rodriguez 857-939-9512
2 Team Number, Bertocci Club 594 Montello St Brockton 508-583-1437 Ronald Jones 508-395-0971
3 Pushin R Luck, Legion 92 Robinson St Hanson 781-294-0151 Josh Hauge 781-291-0267
4 Up In Smoke, Stix and Stones 800 Brockton Ave Abington 339-788-9381 William Dalton 508-468-5134
5 Just Hit The Board, K of C 440 Webster St Rockland 781-871-2407 Tom Morrison 857-249-1022
6 The Outsiders, Dylan's Pub 789 Centre St Brockton 774-381-7103 Brian Henrikson 508-631-9056
7 Engine II, Enterprise Club 224 Clinton St Brockton 508-583-9710 Dick O'Connell 508-326-1751
8 BYE, NO Match 00 No Location 888-000-0000
</SSDivD4>
<SSDivB3>
1 Into the West, Auld Sod 274 Wash St Dedham 781-326-3057 Kevin Ruane 617-966-8801
2 Team Ten Beers, Walpole VFW 109 Robbins Rd Walpole 508-668-1367 Rob McKinney 508-361-9662
3 Dart Knights, Marine Corps League 111 Newbury Ave Quincy 617-479-3505 Stephen Reid 617-773-0175
4 NT Shooters, Napper Tandy's 46 Day St Norwood 781-762-0032 Brian Spillane 781-636-8167
5 Ragged Alcoholics, Rags Tavern 375 Wash St Quincy 617-770-0303 Mike McQuade 781-710-1903
6 BYE, NO Match 00 No Location 888-000-0000
</SSDivB3>
<SSDivB4>
1 Denny's Dawgs, McGreal's Tavern 690 Main St Norwell 781-659-9303 Michael Cole 781-789-2968
2 It's A Night Out, Banner Pub 167 Union St Rockland 781-878-8717 CJ Fuery 617-435-5310
3 Triple Threat, Squires 1202 Wash St Hanover 781-826-3360 Jim Marvin 617-347-2422
4 Indigo Inertia, Towne Line Tavern 390 Court St Plymouth 508-591-7612 Scott Ferguson 508-889-3694
5 Win Some Lose Some, Monte Christos 745 State Rd Ply 508-224-7000 Kent Blethen 774-454-4544
6 Penetrators, Main St Sports Bar 39 Main St Plymouth 774-783-4129 Craig Vogel 508-889-6504
7 BYE, NO Match 00 No Location 888-000-0000
8 6 1/2 Men, Venus II 277 Ocean St Marshfield 781-837-6368 Ross Cocchi 617-699-9552
</SSDivB4>
<SSDivC1>
1 Relentless Nine, Legion 97 Main St Kingston 781-585-7728 Jim Ford 617-828-2992
2 The 26ers, The Jetty 278 Ocean St Marshfield 781-319-2181 Eric Tengberg 781-706-4721
3 DILLIGAF, Lucky Dawg 242 Mattakeesett St Pembroke 781-293-3600 Bruce Cadorette 508-245-3095
4 BYE, NO Match 00 No Location 888-000-0000
5 Gravediggers, Rafferty's 10 Snow Rd Marshfield 781-837-3389 Mike Sullivan 617-816-3382
6 2 In The Pink, Main St Sports Bar 39 Main St Plymouth 774-783-4129 Alex Ledwell 774-773-5850
7 Strange Crew, Ply Moose 601 State Rd Plymouth 508-224-2276 Ray Manning 508-728-5035
8 Fart Chuckers, Main St Sports Bar 39 Main St Plymouth 774-783-4129 Brian Vogel 5018-958-5173
</SSDivC1>
<SSDivC2>
1 Painful to Watch, Protectors Club 50 Herrod Ave Brockton 508-588-9647 Kelly Kelle 774-386-4156
2 Wire We Here?, Stix and Stones 800 Brockton Ave Abington 339-788-9381 Steve Lacey 508-728-3833
3 Crazy 88's, Protectors Club 50 Herrod Ave Brockton 508-588-9647 John Bouffard 508-326-8791
4 I Got This", Bertocci Club 594 Montello St Brockton 508-583-1437 Jim Donlan 978-375-3004
5 Flyin Hawaiians, VFW 61 Rockland St N Easton 508-238-9063 Brian Simpson 774-517-7039
6 Breakfast Club, Great American Pub 1736 Broadway Raynham 508-824-4880 Leon Vitale 603-401-1597
7 Friends of Pic, Club National 170 Court St Brockton 508-583-9652 Mike Prescott 508-916-1684
8 BYE, NO Match 00 No Location 888-000-0000
</SSDivC2>
<SSDivC3>
1 Auld Sod, Auld Sod 274 Wash St Dedham 781-326-3057 Hugh Varden 617-838-6612
2 You've Been Corked, Pete's 540 South St Quincy 617-471-9714 Tricia Grant 617-699-8954
3 Coops Misfits, Coops 520 Wash St Quincy 617-472-2667 Vinny Lento 617-875-9696
4 C.U. Next Tuesday, Pete's 540 South St Quincy 617-471-9714 Kelly Barker 978-835-9659
5 Slippery Nipples, Malachy's 51 Granite St Quincy 617-786-1449 Rick Mandeville 781-864-8107
6 Johnie Rocket, S6 1550 Hancock St Quincy 617-774-1550 Kevin Greene 508-510-0291
7 Who's Round?, Rags Tavern 375 Wash St Quincy 617-770-0303 Paul Emerick 617-592-4996
8 Just Keep Us In Quincy, S6 1550 Hancock St Quincy 617-774-1550 Kevin Arnold 508-369-2984
</SSDivC3>
<SSDivE1>
1 The Circus, Coops 520 Wash St Quincy 617-472-2667 Sara Lefebvre 617-678-4207
2 Almost There, Pete's 540 South St Quincy 617-471-9714 Stacy Nantel 781-424-4289
3 Smells Like Bulls Hit, Shooters Pub 36 E Main St Avon 508-580-0069 Topher Paone 508-577-4195
4 Back In Black, Pete's 540 South St Quincy 617-471-9714 Tom Budreau 617-999-4960
5 Buck A Ton, Cathay Center 211 Bridge St Weymouth 781-337-1856 Linda Wall 774-274-6703
6 Cheese and CrackHors, South Side Tavern 73 Liberty St Quincy 617-328-0511 Dave Anderson 617-717-9207
7 The Wolfpack, Christopher's 1285 Broadway Raynham 508-824-9016 Bob Dykeman 774-244-0158
8 Splash City, Ben's Pour House 39 E Main St Avon 508-584-9200 John Zenus 508-889-6882
</SSDivE1>

<Sched8>
1 1 4
1 2 3
1 6 7
1 5 8
2 8 1
2 7 2
2 3 6
2 4 5
3 4 3
3 7 8
3 1 2
3 6 5
4 8 4
4 3 7
4 5 1
4 2 6
5 4 7
5 8 3
5 1 6
5 5 2
6 3 1
6 4 2
6 6 8
6 7 5
7 6 4
7 5 3
7 1 7
7 2 8
8 4 1
8 3 2
8 7 6
8 8 5
9 1 8
9 2 7
9 6 3
9 5 4
10 3 4
10 8 7
10 2 1
10 5 6
11 4 8
11 7 3
11 1 5
11 6 2
12 7 4
12 3 8
12 6 1
12 2 5
13 1 3
13 2 4
13 8 6
13 5 7
14 4 6
14 3 5
14 7 1
14 8 2
</Sched8>
<Sched6>
1 1 2
1 3 4
1 5 6
2 6 1
2 2 3
2 5 4
3 4 2
3 6 3
3 1 5
4 3 1
4 2 5
4 4 6
5 1 4
5 6 2
5 5 3
6 2 1
6 4 3
6 6 5
7 1 6
7 3 2
7 4 5
8 2 4
8 3 6
8 5 1
9 1 3
9 5 2
9 6 4
10 4 1
10 2 6
10 3 5
11 1 2
11 3 4
11 5 6
12 6 1
12 2 3
12 5 4
13 4 2
13 6 3
13 1 5
14 3 1
14 2 5
14 4 6
15 1 4
15 6 2
15 5 3
</Sched6>


MMDready.bat generated table records above

    Echo=
    Echo=%~nx0 copied %errorlevel% more records from itself to "%LoadFile%"

exit /B %errorlevel%

Rem begin replacement code block for FindREPL clone "MMDfire.bat"

:GetSet2
:GetSet
@echo off & setlocal enableextensions disabledelayedexpansion & Rem First LOCAL scope
Rem Start http://www.dostips.com/forum/viewtopic.php?p=54670#p54670
(set lf=^
%= BLANK LINE REQUIRED =%
)
set "cr=" & if not defined cr for /f "skip=1" %%C in (
'echo(^|replace ? . /w /u'
) do set "cr=%%C"

set ^"orig=  !random!  !  ^^!  ^^^^!  ^"^^  ^&^"^&  ^^^" %%os%%  ^"

call :strim res1 orig

@Echo Off&SetLOCAL EnableDelayedExpansion &Rem.Second LOCAL scope and keep environment uncluttered.
Rem Of all the gin joints, in all the towns, in all the world, she walks into mine
Rem Minute Man - World's largest Steel-Tip Dart League
Rem Start http://www.mmdl.org/

Rem Create prompt strings for division CHOICE commands
    For /F "tokens=* delims=v>" %%E in (
        'type "%~F0" ^| CScript //nologo //E:JScript "%~F0" "^<SSDiv" ^| Sort '
    ) DO (
        Set "Div=%%~E"
        Set "Div=!Div:~6,2!"
        Set "Div1=!Div:~0,1!"
        Set "Div2=!Div:~1,1!"
        If /I "!Div!" EQU "A0" (
            Set "DivV=!Div!
            Set "DivA=S"
            Set "Div#="
            Set "DivP=S[for SUPER A]
        ) Else (
            Set "DivV=!DivV!!Div!
            Set "DivC=!DivA:~-1!"
            If "!DivC!" NEQ "!Div1!" Set "DivA=!DivA!!Div1!"
            If Defined Div# (
                For %%H in (!Div2!) Do Set "DivL=!Div#:%%~H=!"
                If "!DivL!" EQU "!Div#!" Set "Div#=!Div#!!Div2!"
            ) Else (
                Set "Div#=!Div2!"
            )
            Set "DivP=!DivP! !Div!"
        )
    )

    Echo=The board is set to ask for division and team information.
    Echo=
    Echo=Enter four or more letters to search the team lists.
    Echo=Try team, establishment, street, town or city names.
    Echo=Some suggestions may be offered for division selection.
    Echo=Less characters will transfer directly to prompting.
    Echo=
    Set /P "Hint=Press optional search characters and the 'Enter' key: "

Rem Prompt for Division name
:RePromptDiv
CLS
    Call :HintSearch "%Hint%"
    Echo=
    Echo=South Shore Division names starting with SS:
    Echo=  !DivP! (or X to eXit^)
    Set <Nul /P "=Throw a first dart at a alphabetic character: SS"
    CHOICE /C X%DivA% /N
    Set /A "DivPos=%ErrorLevel%-2"
    If /I "%ErrorLevel%" EQU "1" (Echo=Exiting on request. &Exit /B)
    If /I "!DivPos!" EQU "0" (
        Set "MyDiv=A0"
        Goto Divided
    )
    Set "DivA=!DivA:~%DivPos%,1!"
CLS
    Call :HintSearch "%Hint%"
    Echo=
    Echo= South Shore Division names starting with SS:
    Echo= !DivP! (or X to eXit^)
    Set <Nul /P "=Throw the second dart at a numeric character: SS%DivA%"
    CHOICE /C X%Div#%  /N
    Set /A "DivPos=%ErrorLevel%-2"
    If /I "%ErrorLevel%" EQU "1" (Echo=Exiting on request. &Exit /B)
    Set "Div#=!Div#:~%DivPos%,1!"
    Set "MyDiv=%DivA%%Div#%"
:Divided

Rem Validate the selection
    For %%a in (%MyDiv%) do Set "htest=!DivV:%%a=!"
    If /I "!hTest!" EQU "%DivV%" (
        Echo.'%MyDiv%' was not from the list.  Please try again.
        Echo.
        GoTo :RePromptDiv
    ) Else (
        Set "tag=SSDiv%MyDiv%"
        Echo=
        Call :TeamArray rem
    )

    Echo=
    Echo=List of teams in the SS%MyDiv% division:
    For /L %%L In (1,1,%Name[0]%) Do (
        Echo= %%L. '!Name[%%L]!' from '!Home[%%L]!', !Addr[%%L]!
    )
    Set <Nul /P "=Enter a team number for the three dart out (or X to eXit) "
    CHOICE /C %NameP%X
    Set "MyTeam=%errorlevel%"
    Set /A "NameC=%errorlevel%+1"
    If ErrorLevel %NameC% (Echo=Exiting on request. &Exit /B)

    Echo=
    Echo=%MyTeam%. '!Name[%MyTeam%]!' plays out of '!Home[%MyTeam%]!' at !Addr[%MyTeam%]!.
    Echo=Now ready to process the %Team#%-Team Schedule for team %MyTeam%. in the SS%MyDiv% division.

    Echo=
    Set "tag=Week"
    Call :TableArray Rem

    Set "tag=Sched%team#%"
    Call :TableArray rem

Rem Combine pool teams Dates and games
Rem For Minute Man Dart League - HOME TEAM IS ON THE RIGHT

    Set    "file=MMD\team%MyTeam%_Sched.txt"
    Set "PktFile=MMD\team%MyTeam%_PktSched.txt"
    If Not Exist MMD MD MMD
    Echo.
    Echo Creating or replacing contents of:
    Echo.    "%file%"
    Echo.and "%PktFile%"
    >%PktFile% Rem.

(
    Echo.Minute Man Dart League Division Schedule %MYDiv%
    Set "qtr= %MyTeam%. !name[%MyTeam%]!"
    Call :quarters line qtr ""
    >>%PktFile% Echo.!line!
    Echo.Spring 2018 - for team %MyTeam%. !name[%MyTeam%]! from !home[%MyTeam%]!
    Set "qtr= MMDL 02/04 base"
    Call :quarters line qtr
    >>%PktFile% Echo.!line!
    Set "qtr=            "
    Call :quarters line qtr
    >> %PktFile% Echo.!line!
    Echo.Based on MMDL web site Schedule 02/04/2018
    Echo.Customization courtesy of John A. of the Braintree Moose
rem Set "Current=%%~G"
    Echo.

    For /F "tokens=1-3" %%M in (
        'Type "%~f0" ^| CScript //nologo //E:JScript "%~F0" "^<%tag%>" /E:"^</%tag%>" /o:+1:-1'
    ) DO (
        Set "Match=%%~M"
        Set "Guest=%%~N"
        Set "Host=%%~O"
        Set "When=!Week[%%~M]:~,10!"
        Set "sWhen=!When:~,5!"
        For %%G In (!Guest!) Do (
            For %%H In (!Host!) Do (
                If /I "!Host!" EQU "%MyTeam%" (
                    Echo.
                    Echo.[!When!] HOME at !home[%%~H]!
                    If /I "!name[%%~W]!" EQU "Bye" (
                        Echo.NO game for %%~H. !name[%%~H]!
                    ) Else (
                        Echo.Hosting %%~G. !name[%%~G]! from !home[%%~G]!
                    )
                    >>%PktFile% (
                        If /I "!name[%%~G]!" EQU "Bye" (
                            Set "qtr=!sWhen! Bye 
                            Call :quarters line qtr ""
                            Echo.!line!
                        ) Else (
                            Set "sName=!Name[%%G]:~0,7!"
                            Set "qtr=!sWhen! HOME !sName!"
                            Call :quarters line qtr
                            Echo.!line!
                        )
                    )
                ) ELse If /I "!Guest!" EQU "%MyTeam%" (
                    Echo.
                    Set "sName=!Home[%%H]:~0,7!"
                    Set "qtr=!sWhen! !sName! %%~H"
                    Call :quarters line qtr " "
                    >>%PktFile% Echo.!line!
                    Set "sName=!name[%%H]:~0,13!"
                    Set "qtr=!sName! "
                    Call :quarters line qtr ""
                    >>%PktFile% Echo.!line!
                    Echo.[!When!] AWAY at "!Home[%%~H]!" vs. %%~H. !name[%%~H]!
                    Echo.AWAY game at !Addr[%%~H]!
                ) ELse (
                    Rem Echo %MyTeam% is not involved
                )
            )
        )
    )
    Set "qtr=..            .."
    Call :quarters line qtr
    >> %PktFile% Echo.!line!
    Set "qtr= Pocket Edition"
    Call :quarters line qtr ""
    >> %PktFile% Echo.!line!
) > %file%

Rem Splash completion display and perhaps
Rem drop into default editor printing instructions here
Rem Echo.
Rem Type  %file%
Rem Start %PktFile%
Rem Start %file%
    Start MMD

Rem >Nul Pause

    Exit /B

:TableArray
    Set "Do=%~1"
    If not defined Do Set "Do=Set"
    Set /A "CtrW=0"
    For /F "tokens=1* delims= " %%W In (
        'Type "%~f0" ^| CScript //nologo //E:JScript "%~F0" "^<%tag%>" /E:"^</%tag%>" /o:+1:-1'
    ) DO (
        Set /A "CtrW+=1"
        For %%H in (!CtrW!) Do Set %tag%[%%H]=%%~W %%~X
    )
    Set /A  "%tag%[0]=%CtrW%"
    Set "%tag%{Rem}=Echo=The array for the <%tag%> table is now set to !%tag%[0]! entries."
    !%tag%{Rem}!
Rem Display of %tag%[ is optional
    %Do% %tag%[
Exit /B %errorlevel%

:HintSearch
Rem Display search results for division CHOICEs
    Set "Div="
    Set /A "CtrH=0"
    If NOT Defined Hint Exit /B
    Set "Hint=%Hint%   "
    If /I "%Hint:~3,1%" EQU " " Exit /B
    Call :strim Hint Hint
    Echo=Only the first instance of a team related to '%~1' is shown for any division.
Rem The FOR command pipes itself to isolate the tables and avoid searching actual script code
    For /F "tokens=1* delims=," %%E in (
        'type "%~F0" ^| CScript //nologo //E:JScript "%~F0" /I "^<SSDiv" /E:"/SSDiv" /o:+0:-0 ^| CScript //nologo //E:JScript "%~F0" /I "%~1" /E:"/SSDiv" /o:+0:-0'
    ) DO (
        If Not Defined Hints (
            Set "Hint2=%%~F"
            Set "Hint2=!Hint2:~,30!"
            Set "Hints=%%~E. !Hint2!"
        ) ELSe (
            Set "Div=%%~E"
            Set "Div=!Div:~2,5!"
            If /I "!Div!" EQU "SSDiv" (
                Set /A "CtrH+=1"
                Set "HintD=%%E"
                Set "HintD=Div=!HintD:~2,2!!HintD:~7,2!"
                Echo=%%E !HintD! !Hints!
                Set "Hints="
            )
        )
    )
    If Not Defined Div (
        Echo=No suggestions to offer related to '%~1'.
    ) ELSE (
        Echo=Listed %CtrH% suggestions related to '%~1'.
    )
Exit /B %errorlevel%

:TeamArray
    Set "Do=%~1"
    If not defined Do Set "Do=Set"
    Set /A "CtrW=0"
(
    For /F "tokens=1* delims=," %%W In (
        'Type "%~f0" ^| CScript //nologo //E:JScript "%~F0" "^<%tag%>" /E:"^</%tag%>" /o:+1:-1'
    ) DO (
        Set /A "CtrW+=1"
        Set "NameP=!NameP!!CtrW!"
        For %%H in (!CtrW!) Do (
            Set "Name=%%~W"
            Set "Name[%%H]=!Name:~2!"
            Echo=%%~X
        )
    )
) > %Temp%\MMDvenues.txt
    Set /A  "Name[0]=%CtrW%"
    Set "Name{Rem}=Echo=The Name array for the <%tag%> table is now set to !Name[0]! entries."
    !Name{Rem}!
Rem Display of Name[ is optional
    %Do% Name[

Rem Define array of team home establishments and addresses
    Set "CapS=ABCDEFGHIJKLMNOPQRSTUVWXYZ"

    Set /A "Team#=%CtrW%"
    Set /A "CtrW=0"
    For /F "usebackq tokens=1* delims=-" %%F in (
        `Type %Temp%\MMDvenues.txt`
    ) do (
        Set /A "CtrW+=1"
        Set "RecB=%%~F"
        Set "RecB=!RecB:~,-3!"
        Call :strim RecB RecB
        Set "RecAddr="
        Set "RecHome="
        >Nul Call :ArgCtr !recB!
        For /L %%L In (1,1,!ArgCnt!) Do (
            Set "ch=!arg[%%L]!"
            If Defined RecAddr (
                Set "RecAddr=!RecAddr! !ch!"
            ) eLSE (
                Set "test1=!ch:~0,1!"
                For %%a in (!test1!) do Set "test=!caps:%%a=!"
                If /I "!test!" EQU "%CapS%" (
                    Set "RecAddr=!ch!"
                )
            )
            If Not Defined RecAddr (
                Set "RecHome=!RecHome! !ch!"
            )
        )
        Set "Home[!CtrW!]=!recHome:~1!"
        Set "Addr[!CtrW!]=!recAddr!"
    )

    Set /A  "Home[0]=%CtrW%"
    Set "Home{Rem}=Echo=The Home array for the <%tag%> table is now set to !Home[0]! entries."
    !Home{Rem}!
Rem Display of Home[ is optional
    %Do% Home[

    Set /A  "Addr[0]=%CtrW%"
    Set "Addr{Rem}=Echo=The Addr array for the <%tag%> table is now set to !Addr[0]! entries."
    !Addr{Rem}!
Rem Display of Addr[ is optional
    %Do% Addr[

Exit /B %errorlevel%

:Quarters result= original=
:: trims leading and trailing whitespace from a string
setlocal enabledelayedexpansion
set "die=" & if not defined %2 (>&2 echo(var "%2" not defined
set "die=1") elSE set "str=!%2!"

if not defined die for %%L in ("!lf!") ^
do if "!str!" neq "!str:%%~L=!" (
>&2 echo(var "%2" contains linefeeds & set "die=1")

if not defined die for %%C in ("!cr!") ^
do if "!str!" neq "!str:%%~C=!" (
>&2 echo(var "%2" contains carriage returns & set "die=1")

if not defined die (for /f eol^= %%A in ("!str!") do rem nop
) || (>&2 echo(var "%2" consists entirely of whitespace
set "die=1")

if defined die goto die

    Set "sep=%~3"
    If Not Defined sep Set "sep="

    set "str=!str!           "
    set "str=!str:~0,17! !Sep! "
    set "str=!str!!str!!str!!str!"

(endlocal & set "%1=%str%")
exit /b 0

:die
endlocal & set "%1=" & exit /b 1

Rem end of replacement code block for FindREPL clone "MMDfire.bat"



Rem batch subroutines


:ArgCtr
set argCnt=1
:getArgs
Rem Posted: Sun Jan 22, 2012 9:02 pm by dbenham
Rem Post subject: Re: foolproof counting of arguments
Rem Start http://www.dostips.com/forum/viewtopic.php?p=13002#p13002
Rem this[ArgCtr.bat] cloned from Getargs.bat Nov 2,2017 by thefeduke
>"%temp%\getArg.txt" <"%temp%\getArg.txt" (
  setlocal disableExtensions
  set prompt=#
  echo on
  for %%a in (%%a) do rem . %1.
  echo off
  endlocal
  set /p "arg[%argCnt%]="
  set /p "arg[%argCnt%]="
  set "arg[%argCnt%]=!arg[%argCnt%]:~7,-2!"
  if defined arg[%argCnt%] (
    set /a argCnt+=1
    shift /1
    goto :getArgs
  ) else set /a argCnt-=1
)
del "%temp%\getArg.txt"
Exit /B


:strim result= original=
:: trims leading and trailing whitespace from a string
setlocal
set "ddx=!"
setlocal enabledelayedexpansion
set "die=" & if not defined %2 (>&2 echo(var "%2" not defined
set "die=1") else set "str=!%2!"

if not defined die for %%L in ("!lf!") ^
do if "!str!" neq "!str:%%~L=!" (
>&2 echo(var "%2" contains linefeeds & set "die=1")

if not defined die for %%C in ("!cr!") ^
do if "!str!" neq "!str:%%~C=!" (
>&2 echo(var "%2" contains carriage returns & set "die=1")

if not defined die (for /f eol^= %%A in ("!str!") do rem nop
) || (>&2 echo(var "%2" consists entirely of whitespace
set "die=1")

if defined die goto die

set "str=!str:^=^^^^!"
set "str=!str:"=""!"
set "str=%str:!=^^^!%" !

call :_strim "%%str%%

if not defined ddx set "str=!str:^=^^^^!"
if not defined ddx set "str=%str:!=^^^!%" !
set "str=!str:""="!"

for /f tokens^=*^ eol^= %%A in ("!str!") do (
endlocal & endlocal & set "%1=%%A" !)
exit /b 0

:die
endlocal & endlocal & set "%1=" & exit /b 1

:_strim
:: subfunction
set "str=%~1" !
exit /b 0

Rem end of batch subroutines

:showUsage
Rem use of duplicate label intercepts /? HELP

< "%~F0" CScript //nologo //E:JScript "%~F0" "^<dartusage>" /E:"^</dartusage>" /O:+1:-1

    Exit /B

:showUsage
setlocal EnableDelayedExpansion

< "%~F0" CScript //nologo //E:JScript "%~F0" "^<usage>" /E:"^</usage>" /O:+1:-1
set n=1
set "choices="
for %%a in ("http://www.dostips.com/forum/viewtopic.php\Qf=3&t=4697"
            "http://www.dostips.com/forum/viewtopic.php\Qf=3&t=4697&p=38121#p38121"
            "http://msdn.microsoft.com/en-us/library/6wzad2b2(v=vs.84).aspx"
            "http://msdn.microsoft.com/en-us/library/kstkz771(v=vs.84).aspx"
            "http://msdn.microsoft.com/en-us/library/ce57k8d5(v=vs.84).aspx"
            "http://msdn.microsoft.com/en-us/library/htbw4ywd(v=vs.84).aspx") do (
   set "choices=!choices!!n!"
   set "option[!n!]=%%~a"
   set /A n+=1
)

:getOption
echo/
choice /C %choices%0 /N /M "Select one of previous help topics:"
if errorlevel %n% goto :EOF
set "choice=%errorlevel%"
explorer "!option[%choice%]:\Q=?!"
echo  - Help on topic %choice% opened...
goto getOption

End of Batch section


@end


// JScript section



// PARSE PARAMETERS


// FINDREPL [/I] [/V] [/N] rSearch [/E:rEndBlk] [/O:s:e] [/B:rBlock] [/$:1:2...]
//          [[/R] [/A] sReplace] [/Q:c] [/S:source]
//          [/J[:n] [/L:jEnd]] [/G:file]

var options = WScript.Arguments.Named,
    args    = WScript.Arguments.Unnamed,
    env     = WScript.CreateObject("WScript.Shell").Environment("Process"),
    fso     = new ActiveXObject("Scripting.FileSystemObject"), file,

    ignoreCase   = options.Exists("I")?"i":"",
    notMatched   = options.Exists("V"),
    showNumber   = options.Exists("N"),
    search       = undefined,
    endBlk       = undefined,
    offset       = undefined,
    block        = undefined,
    submatches   = undefined,
    justReplaced = options.Exists("R"),
    alternation  = options.Exists("A"),
    replace      = undefined,
    quote        = options.Item("Q"),
    Jexpr        = options.Exists("J"),

    lineNumber = 0, range = new Array(),
    procLines = false, procBlocks = false,
    nextMatch, result  = 0,

    match = function ( line, regex ) { return line.search(regex) >= 0; },

    parseInts =
       function ( strs ) {
          var Ints = new Array();
          for ( var i = 0; i < strs.length; ++i ) {
             Ints[i] = parseInt(strs[i]);
          }
          return Ints;
       },

    getRegExp =
       function ( param, justLoad ) {
          var result = param;
          if ( result.substr(0,1) == "=" ) {
             result = env(result.substr(1));
          } else {
             if ( quote != undefined ) result = result.replace(eval("/"+quote+"/g"),'"');
          }
          if ( ! justLoad ) result = new RegExp(result,"gm"+ignoreCase);
          return result;
       }
    ; // end var

// Predefined variables

for ( var i = 1; block=options.Item("ARG"+i); i++ ) {
   if ( block.substr(0,1) == "=" ) block = env(block.substr(1));
   eval ( 'var ARG'+i+'="'+block+'";' );
}
var daysNow = Math.floor((new Date()).getTime()/86400000), n = 0;
if ( Jexpr) {
   var JexprN = 10;
   if ( options.Item("J") ) JexprN = parseInt(options.Item("J"));
   for ( var i = 1; i <= JexprN; i++ ) eval( "var SUM"+i+"=0,N"+i+"=0,PROD"+i+"=1;" );
}

// Predefined functions

function choose(arg,i){return(arg[i]);};
function max(arg,a,b){var val=-Number.MAX_VALUE; for ( var i=a; i<=b; i++ ) if ( arg[i]>val ) val=arg[i]; return(val);};
function min(arg,a,b){var val= Number.MAX_VALUE; for ( var i=a; i<=b; i++ ) if ( arg[i]<val ) val=arg[i]; return(val);};
function hlookup(arg,lim,a,b){var ind=a; for ( var i=a; i<=b; i++ ) if ( arg[i]>arg[ind] && arg[i]<=lim ) ind=i; return(ind);};
function sum(arg,a,b){var val=0,v; for ( var i=a; i<=b; i++ ) { val+=v=parseFloat(arg[i]); eval("SUM"+i+"+=v;++N"+i+";"); } n=b-a+1; return(val);};
function prod(arg,a,b){var val=1,v; for ( var i=a; i<=b; i++ ) { val*=v=parseFloat(arg[i]); eval("PROD"+i+"*=v;"); } n=b-a+1; return(val);};
function days(s){return(daysNow - Math.floor((new Date(s)).getTime()/86400000));};
function prompt(s){WScript.Stderr.Write('Replace "'+s+'" by: '); return(file.ReadLine());};

if ( file = options.Item("G") ) {
   file = fso.OpenTextFile(file, 1);
   search = "";
   if ( alternation ) replace = "";
   var sepIn = (Jexpr?'||':'|'), sepOut = "";
   while ( ! file.AtEndOfStream ) {
      block = file.ReadLine().split(sepIn);
      search += sepOut+block[0];
      if ( alternation ) replace += sepOut+block[1];
      sepOut = sepIn;
   }
   block = undefined;
   file.Close();
} else {  // No option /G given
   if ( args.length > 0 ) {
      search = getRegExp(args.Item(0),true);
   }
   if ( args.length > 1 ) {
      replace = args.Item(1);
      if ( replace.substr(0,1) == "=" ) replace = env(replace.substr(1));
   }
}
if ( replace ) {  // Check this! It may cause problems when combined with /A and /J
   // replace = eval('"' + replace + '"');
   if ( quote != undefined ) replace = replace.replace(eval("/"+quote+"/g"),'"');
}


if ( options.Exists("E") ) {
   endBlk = getRegExp(options.Item("E"));
   procBlocks = true;
}
if ( options.Exists("O") ) {
   offset = parseInts(options.Item("O").split(":"));
   procBlocks = true;
}
if ( options.Exists("B") ) {
   block = getRegExp(options.Item("B"),true);
}
if ( options.Exists("$") ) submatches = parseInts(options.Item("$").split(":"));
var removeCRLF = false;


if ( replace != undefined ) {
   removeCRLF = (block == "\\r\\n") && (replace == "");

   if ( alternation ) {  // Enable alternation replacements from "Se|ar|ch" to "Re|pla|ce"
      if ( ! Jexpr ) {  // Original version

         var searchA = search.split("|"),
             replaceA = replace.split("|"),
             repl = new Array();
         for ( var i = 0; i < searchA.length; i++ ) {
            repl[searchA[i]] = replaceA[i];
         }
         replace = function($0,$1,$2) { return repl[$0]; };
         searchA.length = 0;
         replaceA.length = 0;

      } else {  // Version 2: Search alternation have regular expressions:  "regexp1||regexp2||regexp3"
                //            Replace alternation have JScript expressions: "'Re'||'pla'||'ce'"

         Jexpr = false;

         var searchA = search.split("||"),      // divide search "regexp1||regexp2||regexp3" in parts
             repl = replace.split("||");      // the same for "replace1||replace2||replace3"
         search = "";
         replace = "$0,";
         for ( var i = 0; i < searchA.length; i++ ) {   // process each regexpI
            search += (i?'|':'')+'('+searchA[i]+')';   // re-assemble search regexp as "(regexp1)|(regexp2)|(regxep3)"
            var subexprs = searchA[i].match(/[^\\]?\(/g);// count subexpressions in this regexpI
            subexprs = subexprs?subexprs.length:0;   // zero if no one
            for ( var j = 0; j <= subexprs; j++ ) {   // insert each subexpression
                  replace += '$'+(i+1)+'$'+j+',';   // 'function($0,' + "$i$0,$i$j,..."
            }
            repl[i] = repl[i].replace(/\$(\d{1,2})/g,"$$"+(i+1)+"$$$1");   // change "$n" by "$i$n" in replaceI
         }

         replace += "$offset,$string";             // 'function($0, $i$0,$i$1,$i$2, ...' + "$offset, $string)"
         eval ( "replace = function("+replace+") { for (var i=1; !eval('$'+i+'$0'); i++); return(eval(repl[i-1])); };" );
         searchA = undefined;
         if ( subexprs ) subexprs = undefined;

      }

   } else {  // No alternation

      var evalReplace = "";
      if ( Jexpr) {
         for ( var i = 0; i <= JexprN; i++ ) evalReplace += (i?',':'')+'$'+i;
         eval ( "evalReplace = function("+evalReplace+") { return(eval(replace)); };" );
      }

   }

} else {  // replace == undefined: Find-only operation (to do: adjust values of /$ switch)

   if ( Jexpr ) {  // Find a "second-level" alternation
      var searchA = search.split("||");         // divide search "regexp1||regexp2||regexp3" in parts
      search = "";
      for ( var i = 0; i < searchA.length; i++ ) {
         search += (i?'|':'')+'('+searchA[i]+')';   // re-assemble search regexp as "(regexp1)|(regexp2)|(regxep3)"
      }
      searchA = undefined;
   }

}

if ( search != undefined ) search = new RegExp(search, "gm"+ignoreCase);
if ( block  != undefined ) block  = new RegExp(block , "gm"+ignoreCase);
file = fso.OpenTextFile("CONIN$", 1);


// PROCESS INPUT FILE


// FINDREPL [/I] [/V] [/N] rSearch [/E:rEndBlk] [/O:s:e] [/B:rBlock] [/$:s1...]
//          [[/R] [/A] sReplace] [/Q:c] [/S:sSource]

//          In Search and Replace operations:
//            /V or /N switches implies line processing
//            /E or /O switches implies block (and line) processing
//          If Search operation (with no previous switches) have NOT /$ switch:
//            implies line processing (otherwise is file processing)

if ( options.Exists("S") ) {  // Process Source string instead of file
   var source = options.Item("S");
   if ( source.substr(0,1) == "=" ) source = env(source.substr(1));
   var fileContents = new Array(), lastLine = 1;
   fileContents[0] = source;
   procLines = true;
} else {  // Process Stdin file

   fileContents = WScript.StdIn.ReadAll();

   if ( notMatched || showNumber || procBlocks ) procLines = true;
   if ( replace==undefined && submatches==undefined ) procLines = true;

   if ( procLines ) {  // Separate file contents in lines
      var lastByte = fileContents.slice(-1);
      fileContents = fileContents.replace(/([^\r\n]*)\r?\n/g,"$1\n").match(/^.*$/gm);
      lastLine = fileContents.length - ((lastByte == "\n")?1:0);
   }

   if ( procBlocks ) {  // Create blocks of lines
      if ( search != undefined ) {  // Blocks based on Search lines:
         if ( offset == undefined ) offset = new Array(0,0);
         for ( var i = 1; i <= lastLine; i++ ) {
            if ( match(fileContents[i-1],search) ) {
               if ( endBlk != undefined ) {  // 1- from Search line to EndBlk line [+offsets].
                  for ( var j=i+1; j<=lastLine && !match(fileContents[j-1],endBlk); j++ );
                  if ( j <= lastLine ) {
                     var s = i+offset[0], e = j+offset[1];
                     // Insert additional code here to cancel overlapped blocks
                     range.push(s>0?s:1, e>0?e:1);
                  }
                  i = j;
               } else {  // 2- surrounding Search lines with offsets.
                  s = i+offset[0], e = i+offset[1];
                  range.push(s>0?s:1, e>0?e:1);
               }
            }
         }
      } else {  // Offset with no Search: block is range of lines
         if ( offset.length < 2 ) offset[1] = lastLine;
         s = offset[0]<0 ? offset[0]+lastLine+1 : offset[0];
         e = offset[1]<0 ? offset[1]+lastLine+1 : offset[1];
         range.push(s>0?s:1, e>0?e:1);
      }
      if ( range.length == 0 ) WScript.Quit(0);
      range.push(0xFFFFFFFF,0xFFFFFFFF);
   }

}
// endif Process Source string instead of file

if ( replace == undefined ) {  // Search operations
   if ( procLines ) {  // Search on lines
      if ( procBlocks ) {  // Process previously created blocks
         for ( var r=0, lineNumber=1; lineNumber <= lastLine; lineNumber++ ) {
            if ( (range[r]<=lineNumber && lineNumber<=range[r+1]) != notMatched ) {
               if ( submatches != undefined ) {
                  if ( showNumber ) WScript.Stdout.Write(lineNumber+":");
                  while ( (nextMatch = block.exec(fileContents[lineNumber-1])) != null ) {
                     for ( var s = 0; s < submatches.length; s++ ) {
                        WScript.Stdout.Write(" " + (quote!=undefined?quote:'"') +
                                                   nextMatch[submatches[s]] +
                                                   (quote!=undefined?quote:'"'));
                     }
                     result++;
                  }
                  WScript.Stdout.WriteLine();
               } else {
                  if ( block == undefined  ||  match(fileContents[lineNumber-1],block) ) {
                     if ( showNumber ) WScript.Stdout.Write(lineNumber+":");
                     WScript.Stdout.WriteLine(fileContents[lineNumber-1]);
                     result++;
                  }
               }
            }
            if ( lineNumber >= range[r+1] ) r += 2;
         }
      } else {  // Process all lines for Search
         for ( lineNumber = 1; lineNumber <= lastLine; lineNumber++ ) {
            if ( match(fileContents[lineNumber-1],search) != notMatched ) {
               if ( showNumber ) WScript.Stdout.Write(lineNumber+":");
               if ( submatches != undefined ) {
                  search.lastIndex = 0;
                  while ( (nextMatch = search.exec(fileContents[lineNumber-1])) != null ) {
                     for ( var s = 0; s < submatches.length; s++ ) {
                        WScript.Stdout.Write(" " + (quote!=undefined?quote:'"') +
                                                   nextMatch[submatches[s]] +
                                                   (quote!=undefined?quote:'"'));
                     }
                     result++;
                  }
                  WScript.Stdout.WriteLine();
               } else {
                  WScript.Stdout.WriteLine(fileContents[lineNumber-1]);
                  result++;
               }
            }
         }
      }

   } else {  // Search on entire file and show submatched substrings
      if ( submatches != undefined ) {
         while ( (nextMatch = search.exec(fileContents)) != null ) {
            for ( var s = 0; s < submatches.length; s++ ) {
               WScript.Stdout.Write(" " + (quote!=undefined?quote:'"') +
                                          nextMatch[submatches[s]] +
                                          (quote!=undefined?quote:'"'));
            }
            result++;
            WScript.Stdout.WriteLine();
         }
      }
   }

} else {  // Replace operations

   if ( procLines ) {  // Replace on lines
      if ( procBlocks ) {  // Process previously created blocks
         if ( block == undefined ) block = search;  // Replace rSearch or rBlock (the last one)
         var CRLFremoved = false;
         for ( var r=0, lineNumber=1; lineNumber <= lastLine; lineNumber++ ) {
            if ( range[r]<=lineNumber && lineNumber<=range[r+1] ) {
               if ( removeCRLF ) {
                  WScript.Stdout.Write(fileContents[lineNumber-1]);
                  CRLFremoved = true;
                  result++;
               } else {
                  if ( match(fileContents[lineNumber-1],block) ) {
                     if ( CRLFremoved ) { WScript.Stdout.WriteLine(); CRLFremoved = false; }
                     WScript.Stdout.WriteLine(fileContents[lineNumber-1].replace(block,Jexpr?evalReplace:replace));
                     result++;
                  } else {
                     if ( CRLFremoved ) { WScript.Stdout.WriteLine(); CRLFremoved = false; }
                     if ( ! justReplaced ) WScript.Stdout.WriteLine(fileContents[lineNumber-1]);
                  }
               }
            } else {
               if ( CRLFremoved ) { WScript.Stdout.WriteLine(); CRLFremoved = false; }
               if ( ! justReplaced ) WScript.Stdout.WriteLine(fileContents[lineNumber-1]);
            }
            if ( lineNumber >= range[r+1] ) r += 2;
         }
         if ( CRLFremoved ) { WScript.Stdout.WriteLine(); CRLFremoved = false; }
      } else {  // Process all lines for Replace
         for ( lineNumber = 1; lineNumber <= lastLine; lineNumber++ ) {
            if ( match(fileContents[lineNumber-1],search) ) {
               WScript.Stdout.WriteLine(fileContents[lineNumber-1].replace(search,Jexpr?evalReplace:replace));
               result++;
            } else {
               if ( ! justReplaced ) WScript.Stdout.WriteLine(fileContents[lineNumber-1]);
            }
         }
      }

   } else {  // Replace on entire file
      WScript.Stdout.Write(fileContents.replace(search,Jexpr?evalReplace:replace));
   }

   if ( lastLine = options.Item("L") ) {
      if ( lastLine.substr(0,1) == '=' ) lastLine = env(lastLine.substr(1));
      WScript.Stdout.WriteLine( eval(lastLine) );
   }

}
WScript.Quit(result);
